make.sh: Pass number of processors and total memory so that we can adjust MAKETUNING
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
06ac8243 20# Copyright (C) 2007-2019 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
fd9a531f 27VERSION="2.21" # Version number
b5ef99df 28CORE="129" # Core Level (Filename)
8818db9a 29PAKFIRE_CORE="128" # Core Level (PAKFIRE)
595e89a8 30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
e8ee3199
AF
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
628e8c3a 39
1b24eec5 40TOOLCHAINVER=20181030
03ad5f93 41
69a6ec55
MT
42###############################################################################
43#
44# Beautifying variables & presentation & input output interface
45#
46###############################################################################
47
f9783277
MT
48# Remember if the shell is interactive or not
49if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51else
52 INTERACTIVE=false
53fi
54
401a1edc
MT
55# Sets or adjusts pretty formatting variables
56resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
69a6ec55 65
401a1edc
MT
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
e9a57acd
MT
73 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
74 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 75}
69a6ec55 76
401a1edc
MT
77# Initially setup terminal
78resize_terminal
f9783277 79
401a1edc
MT
80# Call resize_terminal when terminal is being resized
81trap "resize_terminal" WINCH
69a6ec55
MT
82
83# Define color for messages
84BOLD="\\033[1;39m"
85DONE="\\033[1;32m"
86SKIP="\\033[1;34m"
87WARN="\\033[1;35m"
88FAIL="\\033[1;31m"
89NORMAL="\\033[0;39m"
90
bcb9dc13 91# New architecture variables
dc7d6b20 92HOST_ARCH="$(uname -m)"
94571564 93
69a6ec55
MT
94PWD=$(pwd)
95BASENAME=$(basename $0)
96
15679d9f
MT
97# Debian specific settings
98if [ ! -e /etc/debian_version ]; then
df5e82b3 99 FULLPATH=`which $0`
15679d9f 100else
df5e82b3
MT
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
15679d9f 107fi
df5e82b3 108
69a6ec55 109# This is the directory where make.sh is in
aecbe123 110export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 111
ebaecf2c
AF
112LOGFILE=$BASEDIR/log/_build.preparation.log
113export LOGFILE
15679d9f 114DIR_CHK=$BASEDIR/cache/check
ebaecf2c 115mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 116
69a6ec55
MT
117system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119}
120
121system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133}
134
135configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
7520b95a 147 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
69a6ec55
MT
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
7520b95a 154 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
69a6ec55
MT
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
840f0b9f 161 CFLAGS_ARCH=""
69a6ec55
MT
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
54114eb0 198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
cbcc1351 211 local cpu_max=$(( ${processors} + 1 ))
69a6ec55
MT
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
979f8700
AF
220 # limit to -j23 because perl will not build
221 # more
222 if [ ${parallelism} -gt 23 ]; then
223 parallelism=23
224 fi
225
69a6ec55
MT
226 MAKETUNING="-j${parallelism}"
227 fi
212f17c1
MT
228
229 # Compression parameters
230 # We use mode 8 for reasonable memory usage when decompressing
231 # but with overall good compression
232 XZ_OPT="-8"
233
234 # We try to use as many cores as possible
235 XZ_OPT="${XZ_OPT} -T0"
236
237 # We need to limit memory because XZ uses too much when running
238 # in parallel and it isn't very smart in limiting itself.
239 # We allow XZ to use up to 70% of all system memory.
240 local xz_memory=$(( HOST_MEM * 7 / 10 ))
241
242 # XZ memory cannot be larger than 2GB on 32 bit systems
243 case "${build_arch}" in
244 i*86|armv*)
245 if [ ${xz_memory} -gt 2048 ]; then
246 xz_memory=2048
247 fi
248 ;;
249 esac
250
251 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
252}
253
254configure_build_guess() {
255 case "${HOST_ARCH}" in
87487585
MT
256 x86_64)
257 echo "x86_64"
258 ;;
259 i?86)
69a6ec55
MT
260 echo "i586"
261 ;;
262
263 aarch64)
264 echo "aarch64"
265 ;;
266
267 armv7*|armv6*|armv5*)
268 echo "armv5tel"
269 ;;
270
271 *)
272 exiterror "Cannot guess build architecture"
273 ;;
274 esac
275}
276
f9783277
MT
277stdumount() {
278 umount $BASEDIR/build/sys 2>/dev/null;
279 umount $BASEDIR/build/dev/shm 2>/dev/null;
280 umount $BASEDIR/build/dev/pts 2>/dev/null;
281 umount $BASEDIR/build/dev 2>/dev/null;
282 umount $BASEDIR/build/proc 2>/dev/null;
283 umount $BASEDIR/build/install/mnt 2>/dev/null;
284 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
285 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/config 2>/dev/null;
287 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
288 umount $BASEDIR/build/usr/src/html 2>/dev/null;
289 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
290 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 291 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277
MT
292 umount $BASEDIR/build/usr/src/src 2>/dev/null;
293}
294
295now() {
296 date -u "+%s"
69a6ec55
MT
297}
298
f9783277
MT
299format_runtime() {
300 local seconds=${1}
301
302 if [ ${seconds} -ge 3600 ]; then
303 printf "%d:%02d:%02d\n" \
304 "$(( seconds / 3600 ))" \
305 "$(( seconds % 3600 / 60 ))" \
306 "$(( seconds % 3600 % 60 ))"
307 elif [ ${seconds} -ge 60 ]; then
308 printf "%d:%02d\n" \
309 "$(( seconds / 60 ))" \
310 "$(( seconds % 60 ))"
69a6ec55 311 else
f9783277 312 printf "%d\n" "${seconds}"
69a6ec55 313 fi
f9783277 314}
69a6ec55 315
f9783277
MT
316print_line() {
317 local line="$@"
69a6ec55 318
f9783277 319 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
320}
321
f9783277
MT
322_print_line() {
323 local status="${1}"
324 shift
69a6ec55 325
f9783277
MT
326 if ${INTERACTIVE}; then
327 printf "${!status}"
328 fi
69a6ec55 329
f9783277
MT
330 print_line "$@"
331
332 if ${INTERACTIVE}; then
333 printf "${NORMAL}"
334 fi
335}
336
337print_headline() {
338 _print_line BOLD "$@"
69a6ec55
MT
339}
340
f9783277
MT
341print_error() {
342 _print_line FAIL "$@"
343}
344
345print_package() {
346 local name="${1}"
347 shift
69a6ec55 348
f9783277
MT
349 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
350 local options="$@"
351
352 local string="${name}"
353 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
354 string="${string} (${version})"
355 fi
356
357 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 358 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
359}
360
361print_runtime() {
362 local runtime=$(format_runtime $@)
363
364 if ${INTERACTIVE}; then
365 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
366 else
367 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 368 fi
f9783277
MT
369}
370
371print_status() {
372 local status="${1}"
373
374 local color="${!status}"
375
376 if ${INTERACTIVE}; then
377 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
378 else
379 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 380 fi
f9783277 381}
69a6ec55 382
f9783277
MT
383print_build_stage() {
384 print_headline "$@"
385
386 # end line
387 printf "\n"
69a6ec55
MT
388}
389
f9783277
MT
390print_build_summary() {
391 local runtime=$(format_runtime $@)
392
393 print_line "*** Build finished in ${runtime}"
394 print_status DONE
69a6ec55
MT
395}
396
397exiterror() {
398 stdumount
399 for i in `seq 0 7`; do
400 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
401 losetup -d /dev/loop${i} 2>/dev/null
402 fi;
403 done
404
f9783277 405 # Dump logfile
66028310 406 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
407 echo # empty line
408
409 local line
410 while read -r line; do
411 echo " ${line}"
412 done <<< "$(tail -n30 ${LOGFILE})"
413 fi
414
f9783277
MT
415 echo # empty line
416
417 local line
418 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
419 print_error "${line}"
420 print_status FAIL
421 done
422
69a6ec55
MT
423 exit 1
424}
425
aecbe123
MT
426prepareenv() {
427 # Are we running the right shell?
54328605 428 if [ -z "${BASH}" ]; then
aecbe123
MT
429 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
430 fi
431
432 if [ -z "${BASH_VERSION}" ]; then
433 exiterror "Not running BASH shell."
434 fi
435
436 # Trap on emergency exit
437 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
438
439 # Resetting our nice level
658232a6 440 if ! renice ${NICE} $$ >/dev/null; then
658232a6 441 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
442 fi
443
444 # Checking if running as root user
658232a6 445 if [ $(id -u) -ne 0 ]; then
df7f30a1 446 exiterror "root privileges required for building"
aecbe123
MT
447 fi
448
449 # Checking for necessary temporary space
f9783277 450 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
451 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
452 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
453 if (( 2048000 > $BASE_ASPACE )); then
454 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
455 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 456 print_status FAIL
aecbe123
MT
457 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
458 fi
459 else
f9783277 460 print_status DONE
aecbe123
MT
461 fi
462
463 # Set umask
464 umask 022
465
466 # Set LFS Directory
467 LFS=$BASEDIR/build
468
aecbe123
MT
469 # Setup environment
470 set +h
471 LC_ALL=POSIX
472 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
473 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
474
475 # Make some extra directories
476 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
477 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
478 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
479 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
ebaecf2c 480 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
481
482 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
483 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
484
485 # Make all sources and proc available under lfs build
486 mount --bind /dev $BASEDIR/build/dev
487 mount --bind /dev/pts $BASEDIR/build/dev/pts
488 mount --bind /dev/shm $BASEDIR/build/dev/shm
489 mount --bind /proc $BASEDIR/build/proc
490 mount --bind /sys $BASEDIR/build/sys
491 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
492 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
493 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
494 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
495 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
496 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
497 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 498 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
499 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
500
501 # Run LFS static binary creation scripts one by one
502 export CCACHE_DIR=$BASEDIR/ccache
503 export CCACHE_COMPRESS=1
504 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
505
506 # Remove pre-install list of installed files in case user erase some files before rebuild
507 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
508
509 # Prepare string for /etc/system-release.
510 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
511 if [ "$(git status -s | wc -l)" == "0" ]; then
512 GIT_STATUS=""
513 else
514 GIT_STATUS="-dirty"
515 fi
516 case "$GIT_BRANCH" in
517 core*|beta?|rc?)
518 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
519 ;;
520 *)
521 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
522 ;;
523 esac
524}
525
69a6ec55
MT
526enterchroot() {
527 # Install QEMU helper, if needed
528 qemu_install_helper
529
530 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
531
532 PATH="${PATH}" chroot ${LFS} env -i \
533 HOME="/root" \
534 TERM="${TERM}" \
535 PS1="${PS1}" \
536 PATH="${PATH}" \
537 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
538 PAKFIRE_CORE="${PAKFIRE_CORE}" \
539 NAME="${NAME}" \
540 SNAME="${SNAME}" \
541 VERSION="${VERSION}" \
542 CORE="${CORE}" \
543 SLOGAN="${SLOGAN}" \
544 TOOLS_DIR="${TOOLS_DIR}" \
545 CONFIG_ROOT="${CONFIG_ROOT}" \
546 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
547 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
548 BUILDTARGET="${BUILDTARGET}" \
549 CROSSTARGET="${CROSSTARGET}" \
550 BUILD_ARCH="${BUILD_ARCH}" \
551 BUILD_PLATFORM="${BUILD_PLATFORM}" \
552 CCACHE_DIR=/usr/src/ccache \
553 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
554 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
555 KVER="${KVER}" \
0d7a6f03 556 XZ_OPT="${XZ_OPT}" \
85560933
MT
557 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
558 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
559 $(fake_environ) \
560 $(qemu_environ) \
561 "$@"
562}
563
564entershell() {
565 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
566 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
567 fi
568
569 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 570 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
571
572 if enterchroot bash -i; then
573 stdumount
574 else
f9783277 575 print_status FAIL
69a6ec55
MT
576 exiterror "chroot error"
577 fi
578}
579
580lfsmakecommoncheck() {
581 # Script present?
582 if [ ! -f $BASEDIR/lfs/$1 ]; then
583 exiterror "No such file or directory: $BASEDIR/$1"
584 fi
585
f9783277
MT
586 # Print package name and version
587 print_package $@
69a6ec55
MT
588
589 # Check if this package is supported by our architecture.
590 # If no SUP_ARCH is found, we assume the package can be built for all.
591 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
592 # Check if package supports ${BUILD_ARCH} or all architectures.
593 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 594 print_runtime 0
f9783277 595 print_status SKIP
69a6ec55
MT
596 return 1
597 fi
598 fi
599
600 # Script slipped?
601 local i
602 for i in $SKIP_PACKAGE_LIST
603 do
604 if [ "$i" == "$1" ]; then
f9783277 605 print_status SKIP
69a6ec55
MT
606 return 1;
607 fi
608 done
609
610 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
611
612 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
613 MESSAGE="$1\t " download >> $LOGFILE 2>&1
614 if [ $? -ne 0 ]; then
615 exiterror "Download error in $1"
616 fi
617
618 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
619 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
620 if [ $? -ne 0 ]; then
621 exiterror "md5sum error in $1, check file in cache or signature"
622 fi
623
624 return 0 # pass all!
625}
626
627lfsmake1() {
628 lfsmakecommoncheck $*
629 [ $? == 1 ] && return 0
630
69a6ec55
MT
631 cd $BASEDIR/lfs && env -i \
632 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
633 CCACHE_DIR="${CCACHE_DIR}" \
634 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
635 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
636 CFLAGS="${CFLAGS}" \
637 CXXFLAGS="${CXXFLAGS}" \
638 MAKETUNING="${MAKETUNING}" \
85560933
MT
639 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
640 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
641 make -f $* \
642 TOOLCHAIN=1 \
643 TOOLS_DIR="${TOOLS_DIR}" \
644 CROSSTARGET="${CROSSTARGET}" \
645 BUILDTARGET="${BUILDTARGET}" \
646 BUILD_ARCH="${BUILD_ARCH}" \
647 BUILD_PLATFORM="${BUILD_PLATFORM}" \
648 LFS_BASEDIR="${BASEDIR}" \
649 ROOT="${LFS}" \
650 KVER="${KVER}" \
f9783277 651 install >> $LOGFILE 2>&1 &
69a6ec55 652
f9783277
MT
653 if ! wait_until_finished $!; then
654 print_status FAIL
655 exiterror "Building $*"
69a6ec55
MT
656 fi
657
f9783277 658 print_status DONE
69a6ec55
MT
659}
660
661lfsmake2() {
662 lfsmakecommoncheck $*
663 [ $? == 1 ] && return 0
664
69a6ec55
MT
665 local PS1='\u:\w$ '
666
667 enterchroot \
ce9264a1 668 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
669 MAKETUNING=${MAKETUNING} \
670 make -f $* \
671 LFS_BASEDIR=/usr/src install" \
f9783277 672 >> ${LOGFILE} 2>&1 &
69a6ec55 673
f9783277
MT
674 if ! wait_until_finished $!; then
675 print_status FAIL
676 exiterror "Building $*"
69a6ec55
MT
677 fi
678
f9783277 679 print_status DONE
69a6ec55
MT
680}
681
682ipfiredist() {
683 lfsmakecommoncheck $*
684 [ $? == 1 ] && return 0
685
69a6ec55
MT
686 local PS1='\u:\w$ '
687
688 enterchroot \
689 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 690 >> ${LOGFILE} 2>&1 &
69a6ec55 691
f9783277
MT
692 if ! wait_until_finished $!; then
693 print_status FAIL
694 exiterror "Packaging $*"
695 fi
69a6ec55 696
f9783277
MT
697 print_status DONE
698}
699
700wait_until_finished() {
701 local pid=${1}
702
703 local start_time=$(now)
704
705 # Show progress
706 if ${INTERACTIVE}; then
707 # Wait a little just in case the process
708 # has finished very quickly.
709 sleep 0.1
710
711 local runtime
712 while kill -0 ${pid} 2>/dev/null; do
713 print_runtime $(( $(now) - ${start_time} ))
714
715 # Wait a little
716 sleep 1
717 done
69a6ec55 718 fi
f9783277
MT
719
720 # Returns the exit code of the child process
721 wait ${pid}
722 local ret=$?
723
724 if ! ${INTERACTIVE}; then
725 print_runtime $(( $(now) - ${start_time} ))
726 fi
727
728 return ${ret}
69a6ec55
MT
729}
730
731fake_environ() {
732 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
733
734 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
735
736 # Fake kernel version, because some of the packages do not compile
737 # with kernel 3.0 and later.
738 env="${env} UTS_RELEASE=${KVER}"
739
740 # Fake machine version.
741 env="${env} UTS_MACHINE=${BUILD_ARCH}"
742
743 echo "${env}"
744}
745
746qemu_environ() {
747 local env
748
749 # Don't add anything if qemu is not used.
750 if ! qemu_is_required; then
751 return
752 fi
753
754 # Set default qemu options
755 case "${BUILD_ARCH}" in
756 arm*)
757 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
758
759 env="${env} QEMU_CPU=${QEMU_CPU}"
760 ;;
761 esac
762
763 # Enable QEMU strace
764 #env="${env} QEMU_STRACE=1"
765
766 echo "${env}"
767}
768
769qemu_is_required() {
770 local build_arch="${1}"
771
772 if [ -z "${build_arch}" ]; then
773 build_arch="${BUILD_ARCH}"
774 fi
775
776 case "${HOST_ARCH},${build_arch}" in
777 x86_64,arm*|i?86,arm*|i?86,x86_64)
778 return 0
779 ;;
780 *)
781 return 1
782 ;;
783 esac
784}
785
786qemu_install_helper() {
787 # Do nothing, if qemu is not required
788 if ! qemu_is_required; then
789 return 0
790 fi
791
792 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
793 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
794 fi
795
796 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
797 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
798 fi
799
800
801 if [ -z "${QEMU_TARGET_HELPER}" ]; then
802 exiterror "QEMU_TARGET_HELPER not set"
803 fi
804
805 # Check if the helper is already installed.
806 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
807 return 0
808 fi
809
810 # Try to find a suitable binary that we can install
811 # to the build environment.
812 local file
813 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
814 # file must exist and be executable.
815 [ -x "${file}" ] || continue
816
817 # Must be static.
818 file_is_static "${file}" || continue
819
820 local dirname="${LFS}$(dirname "${file}")"
821 mkdir -p "${dirname}"
822
823 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
824 return 0
825 done
826
827 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
828}
829
830qemu_find_build_helper_name() {
831 local build_arch="${1}"
832
833 local magic
834 case "${build_arch}" in
835 arm*)
836 magic="7f454c4601010100000000000000000002002800"
837 ;;
838 x86_64)
839 magic="7f454c4602010100000000000000000002003e00"
840 ;;
841 esac
842
843 [ -z "${magic}" ] && return 1
844
845 local file
846 for file in /proc/sys/fs/binfmt_misc/*; do
847 # skip write only register entry
848 [ $(basename "${file}") = "register" ] && continue
849 # Search for the file with the correct magic value.
850 grep -qE "^magic ${magic}$" "${file}" || continue
851
852 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
853
854 [ -n "${interpreter}" ] || continue
855 [ "${interpreter:0:1}" = "/" ] || continue
856 [ -x "${interpreter}" ] || continue
857
858 echo "${interpreter}"
859 return 0
860 done
861
862 return 1
863}
864
865file_is_static() {
866 local file="${1}"
867
868 file ${file} 2>/dev/null | grep -q "statically linked"
869}
870
871update_language_list() {
872 local path="${1}"
873
874 local lang
875 for lang in ${path}/*.po; do
876 lang="$(basename "${lang}")"
877 echo "${lang%*.po}"
878 done | sort -u > "${path}/LINGUAS"
879}
880
1fb7f56e
MT
881contributors() {
882 local commits name
883
884 git shortlog --summary --numbered | while read -r commits name; do
885 echo "${name}"
886 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
887}
888
889update_contributors() {
890 echo -n "Updating list of contributors"
891
892 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
893
894 # Edit contributors into credits.cgi
895 awk -i inplace \
896 "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
897 "${BASEDIR}/html/cgi-bin/credits.cgi"
898
899 print_status DONE
900 return 0
901}
902
a98ab1d7
MT
903# Load configuration file
904if [ -f .config ]; then
905 . .config
906fi
907
813659f2
MT
908# TARGET_ARCH is BUILD_ARCH now
909if [ -n "${TARGET_ARCH}" ]; then
910 BUILD_ARCH="${TARGET_ARCH}"
911 unset TARGET_ARCH
912fi
913
85560933
MT
914# Get some information about the host system
915SYSTEM_PROCESSORS="$(system_processors)"
916SYSTEM_MEMORY="$(system_memory)"
917
5190eea2
MT
918# Get the amount of memory in this build system
919HOST_MEM=$(system_memory)
920
dc7d6b20
MT
921if [ -n "${BUILD_ARCH}" ]; then
922 configure_build "${BUILD_ARCH}"
949544f5 923else
dc7d6b20 924 configure_build "default"
949544f5
MT
925fi
926
df5e82b3 927buildtoolchain() {
69a6ec55
MT
928 local error=false
929 case "${BUILD_ARCH}:${HOST_ARCH}" in
930 # x86_64
931 x86_64:x86_64)
932 # This is working.
933 ;;
934
935 # x86
936 i586:i586|i586:i686|i586:x86_64)
937 # These are working.
938 ;;
939 i586:*)
940 error=true
941 ;;
942
943 # ARM
944 arvm7hl:armv7hl|armv7hl:armv7l)
945 # These are working.
946 ;;
947
948 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
949 # These are working.
950 ;;
951 armv5tel:*)
952 error=true
953 ;;
954 esac
955
956 ${error} && \
957 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
958
959 local gcc=$(type -p gcc)
960 if [ -z "${gcc}" ]; then
961 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
962 fi
963
6bd3a131
MT
964 # Check ${TOOLS_DIR} symlink
965 if [ -h "${TOOLS_DIR}" ]; then
966 rm -f "${TOOLS_DIR}"
967 fi
968
969 if [ ! -e "${TOOLS_DIR}" ]; then
970 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
971 fi
972
973 if [ ! -h "${TOOLS_DIR}" ]; then
974 exiterror "Could not create ${TOOLS_DIR} symbolic link"
975 fi
976
ebaecf2c 977 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
978 export LOGFILE
979
980 lfsmake1 stage1
981 lfsmake1 ccache PASS=1
982 lfsmake1 binutils PASS=1
983 lfsmake1 gcc PASS=1
984 lfsmake1 linux KCFG="-headers"
985 lfsmake1 glibc
986 lfsmake1 gcc PASS=L
987 lfsmake1 binutils PASS=2
988 lfsmake1 gcc PASS=2
54d54148 989 lfsmake1 zlib
69a6ec55
MT
990 lfsmake1 ccache PASS=2
991 lfsmake1 tcl
992 lfsmake1 expect
993 lfsmake1 dejagnu
994 lfsmake1 pkg-config
995 lfsmake1 ncurses
996 lfsmake1 bash
997 lfsmake1 bzip2
998 lfsmake1 automake
999 lfsmake1 coreutils
1000 lfsmake1 diffutils
1001 lfsmake1 findutils
1002 lfsmake1 gawk
1003 lfsmake1 gettext
1004 lfsmake1 grep
1005 lfsmake1 gzip
1006 lfsmake1 m4
1007 lfsmake1 make
1008 lfsmake1 patch
1009 lfsmake1 perl
1010 lfsmake1 sed
1011 lfsmake1 tar
1012 lfsmake1 texinfo
1013 lfsmake1 xz
85439ac7 1014 lfsmake1 bison
11b5e5cb 1015 lfsmake1 flex
69a6ec55 1016 lfsmake1 fake-environ
7b93b62b 1017 lfsmake1 strip
69a6ec55 1018 lfsmake1 cleanup-toolchain
df5e82b3
MT
1019}
1020
1021buildbase() {
ebaecf2c 1022 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1023 export LOGFILE
1024 lfsmake2 stage2
1025 lfsmake2 linux KCFG="-headers"
1026 lfsmake2 man-pages
1027 lfsmake2 glibc
1028 lfsmake2 tzdata
1029 lfsmake2 cleanup-toolchain
1030 lfsmake2 zlib
1031 lfsmake2 binutils
1032 lfsmake2 gmp
1033 lfsmake2 gmp-compat
1034 lfsmake2 mpfr
1035 lfsmake2 libmpc
1036 lfsmake2 file
1037 lfsmake2 gcc
1038 lfsmake2 sed
1039 lfsmake2 autoconf
1040 lfsmake2 automake
1041 lfsmake2 berkeley
1042 lfsmake2 coreutils
1043 lfsmake2 iana-etc
1044 lfsmake2 m4
1045 lfsmake2 bison
69a6ec55
MT
1046 lfsmake2 ncurses
1047 lfsmake2 procps
1048 lfsmake2 libtool
1049 lfsmake2 perl
1050 lfsmake2 readline
1051 lfsmake2 readline-compat
1052 lfsmake2 bzip2
3ece7859 1053 lfsmake2 xz
69a6ec55
MT
1054 lfsmake2 pcre
1055 lfsmake2 pcre-compat
1056 lfsmake2 bash
1057 lfsmake2 diffutils
1058 lfsmake2 e2fsprogs
1059 lfsmake2 ed
1060 lfsmake2 findutils
1061 lfsmake2 flex
1062 lfsmake2 gawk
1063 lfsmake2 gettext
1064 lfsmake2 grep
1065 lfsmake2 groff
1066 lfsmake2 gperf
1067 lfsmake2 gzip
1068 lfsmake2 hostname
1069 lfsmake2 iproute2
1070 lfsmake2 jwhois
1071 lfsmake2 kbd
1072 lfsmake2 less
4720fa0d 1073 lfsmake2 pkg-config
69a6ec55
MT
1074 lfsmake2 make
1075 lfsmake2 man
1076 lfsmake2 kmod
1077 lfsmake2 net-tools
1078 lfsmake2 patch
1079 lfsmake2 psmisc
1080 lfsmake2 shadow
1081 lfsmake2 sysklogd
1082 lfsmake2 sysvinit
1083 lfsmake2 tar
1084 lfsmake2 texinfo
1085 lfsmake2 util-linux
1086 lfsmake2 udev
1087 lfsmake2 vim
df5e82b3
MT
1088}
1089
15679d9f 1090buildipfire() {
ebaecf2c 1091 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1092 export LOGFILE
489145db
MT
1093 lfsmake2 configroot
1094 lfsmake2 initscripts
1095 lfsmake2 backup
c38f55fe
MT
1096 lfsmake2 openssl
1097 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
3755e358 1098 lfsmake2 popt
489145db
MT
1099 lfsmake2 libusb
1100 lfsmake2 libusb-compat
1101 lfsmake2 libpcap
1102 lfsmake2 ppp
1103 lfsmake2 pptp
1104 lfsmake2 unzip
1105 lfsmake2 which
1106 lfsmake2 linux-firmware
489145db 1107 lfsmake2 dvb-firmwares
37b86fa9 1108 lfsmake2 xr819-firmware
489145db
MT
1109 lfsmake2 zd1211-firmware
1110 lfsmake2 rpi-firmware
26796f3a 1111 lfsmake2 intel-microcode
489145db 1112 lfsmake2 bc
2a0947f2 1113 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1114 lfsmake2 cpio
1115 lfsmake2 mdadm
1116 lfsmake2 dracut
de18b4de 1117 lfsmake2 libaio
489145db
MT
1118 lfsmake2 lvm2
1119 lfsmake2 multipath-tools
1120 lfsmake2 freetype
1121 lfsmake2 grub
fd80e500
MT
1122 lfsmake2 efivar
1123 lfsmake2 efibootmgr
489145db
MT
1124 lfsmake2 libmnl
1125 lfsmake2 libnfnetlink
1126 lfsmake2 libnetfilter_queue
1127 lfsmake2 libnetfilter_conntrack
1128 lfsmake2 libnetfilter_cthelper
1129 lfsmake2 libnetfilter_cttimeout
1130 lfsmake2 iptables
0245f3b6 1131 lfsmake2 screen
54ead8ef 1132 lfsmake2 elfutils
8e6fb99d 1133
dc7d6b20 1134 case "${BUILD_ARCH}" in
68a36e26 1135 x86_64|aarch64)
489145db 1136 lfsmake2 linux KCFG=""
b389d731
AF
1137# lfsmake2 backports KCFG=""
1138# lfsmake2 e1000e KCFG=""
1139# lfsmake2 igb KCFG=""
1140# lfsmake2 ixgbe KCFG=""
489145db
MT
1141 lfsmake2 xtables-addons KCFG=""
1142 lfsmake2 linux-initrd KCFG=""
fc155193 1143 ;;
3d02c091
MT
1144 i586)
1145 # x86-pae (Native and new XEN) kernel build
489145db 1146 lfsmake2 linux KCFG="-pae"
b389d731
AF
1147# lfsmake2 backports KCFG="-pae"
1148# lfsmake2 e1000e KCFG="-pae"
1149# lfsmake2 igb KCFG="-pae"
1150# lfsmake2 ixgbe KCFG="-pae"
489145db
MT
1151 lfsmake2 xtables-addons KCFG="-pae"
1152 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1153
1154 # x86 kernel build
489145db 1155 lfsmake2 linux KCFG=""
b389d731
AF
1156# lfsmake2 backports KCFG=""
1157# lfsmake2 e1000e KCFG=""
1158# lfsmake2 igb KCFG=""
1159# lfsmake2 ixgbe KCFG=""
489145db
MT
1160 lfsmake2 xtables-addons KCFG=""
1161 lfsmake2 linux-initrd KCFG=""
3d02c091 1162 ;;
544f40d4 1163
3d02c091 1164 armv5tel)
3d02c091 1165 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
489145db 1166 lfsmake2 linux KCFG="-kirkwood"
0a21d63f
AF
1167# lfsmake2 backports KCFG="-kirkwood"
1168# lfsmake2 e1000e KCFG="-kirkwood"
1169# lfsmake2 igb KCFG="-kirkwood"
1170# lfsmake2 ixgbe KCFG="-kirkwood"
489145db
MT
1171 lfsmake2 xtables-addons KCFG="-kirkwood"
1172 lfsmake2 linux-initrd KCFG="-kirkwood"
3d02c091
MT
1173
1174 # arm multi platform (Panda, Wandboard ...) kernel build
489145db 1175 lfsmake2 linux KCFG="-multi"
0a21d63f
AF
1176# lfsmake2 backports KCFG="-multi"
1177# lfsmake2 e1000e KCFG="-multi"
1178# lfsmake2 igb KCFG="-multi"
1179# lfsmake2 ixgbe KCFG="-multi"
489145db
MT
1180 lfsmake2 xtables-addons KCFG="-multi"
1181 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1182 ;;
1183 esac
489145db 1184 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1185 lfsmake2 libgpg-error
1186 lfsmake2 libgcrypt
1187 lfsmake2 libassuan
1188 lfsmake2 nettle
1a7db134 1189 lfsmake2 json-c
f3e62301 1190 lfsmake2 libconfig
489145db
MT
1191 lfsmake2 libevent
1192 lfsmake2 libevent2
1193 lfsmake2 expat
c8e9a7a8
WA
1194 lfsmake2 apr
1195 lfsmake2 aprutil
489145db
MT
1196 lfsmake2 unbound
1197 lfsmake2 gnutls
1198 lfsmake2 bind
1199 lfsmake2 dhcp
1200 lfsmake2 dhcpcd
1201 lfsmake2 boost
1202 lfsmake2 linux-atm
1203 lfsmake2 gdbm
1204 lfsmake2 pam
1205 lfsmake2 curl
1206 lfsmake2 tcl
1207 lfsmake2 sqlite
1208 lfsmake2 libffi
1209 lfsmake2 python
1210 lfsmake2 python3
1211 lfsmake2 ca-certificates
1212 lfsmake2 fireinfo
1213 lfsmake2 libnet
1214 lfsmake2 libnl
1215 lfsmake2 libnl-3
1216 lfsmake2 libidn
1217 lfsmake2 nasm
1218 lfsmake2 libjpeg
1219 lfsmake2 libjpeg-compat
1220 lfsmake2 libexif
1221 lfsmake2 libpng
1222 lfsmake2 libtiff
1223 lfsmake2 libart
1224 lfsmake2 gd
489145db
MT
1225 lfsmake2 slang
1226 lfsmake2 newt
1227 lfsmake2 libsmooth
1228 lfsmake2 attr
1229 lfsmake2 acl
1230 lfsmake2 libcap
1231 lfsmake2 pciutils
1232 lfsmake2 usbutils
1233 lfsmake2 libxml2
1234 lfsmake2 libxslt
1235 lfsmake2 BerkeleyDB
489145db
MT
1236 lfsmake2 cyrus-sasl
1237 lfsmake2 openldap
1238 lfsmake2 apache2
489145db
MT
1239 lfsmake2 web-user-interface
1240 lfsmake2 flag-icons
1241 lfsmake2 jquery
6033b271 1242 lfsmake2 bootstrap
489145db
MT
1243 lfsmake2 arping
1244 lfsmake2 beep
78dd680d
MT
1245 lfsmake2 libarchive
1246 lfsmake2 cmake
8a960584 1247 lfsmake2 cdrkit
489145db
MT
1248 lfsmake2 dosfstools
1249 lfsmake2 reiserfsprogs
1250 lfsmake2 xfsprogs
1251 lfsmake2 sysfsutils
1252 lfsmake2 fuse
1253 lfsmake2 ntfs-3g
1254 lfsmake2 ethtool
1255 lfsmake2 ez-ipupdate
1256 lfsmake2 fcron
1257 lfsmake2 perl-GD
1258 lfsmake2 GD-Graph
1259 lfsmake2 GD-TextUtil
1260 lfsmake2 perl-Device-SerialPort
1261 lfsmake2 perl-Device-Modem
1262 lfsmake2 perl-Apache-Htpasswd
1263 lfsmake2 gnupg
1264 lfsmake2 hdparm
1265 lfsmake2 sdparm
1266 lfsmake2 mtools
1267 lfsmake2 whatmask
1268 lfsmake2 conntrack-tools
1269 lfsmake2 libupnp
1270 lfsmake2 ipaddr
1271 lfsmake2 iputils
1272 lfsmake2 l7-protocols
489145db
MT
1273 lfsmake2 hwdata
1274 lfsmake2 logrotate
1275 lfsmake2 logwatch
1276 lfsmake2 misc-progs
1277 lfsmake2 nano
1278 lfsmake2 URI
1279 lfsmake2 HTML-Tagset
1280 lfsmake2 HTML-Parser
1281 lfsmake2 HTML-Template
1282 lfsmake2 Compress-Zlib
1283 lfsmake2 Digest
1284 lfsmake2 Digest-SHA1
1285 lfsmake2 Digest-HMAC
1286 lfsmake2 libwww-perl
1287 lfsmake2 Net-DNS
1288 lfsmake2 Net-IPv4Addr
1289 lfsmake2 Net_SSLeay
1290 lfsmake2 IO-Stringy
1291 lfsmake2 IO-Socket-SSL
1292 lfsmake2 Unix-Syslog
1293 lfsmake2 Mail-Tools
1294 lfsmake2 MIME-Tools
1295 lfsmake2 Net-Server
1296 lfsmake2 Convert-TNEF
1297 lfsmake2 Convert-UUlib
1298 lfsmake2 Archive-Tar
1299 lfsmake2 Archive-Zip
1300 lfsmake2 Text-Tabs+Wrap
1301 lfsmake2 Locale-Country
1302 lfsmake2 XML-Parser
1303 lfsmake2 Crypt-PasswdMD5
1304 lfsmake2 Net-Telnet
1305 lfsmake2 python-setuptools
1306 lfsmake2 python-clientform
1307 lfsmake2 python-mechanize
1308 lfsmake2 python-feedparser
1309 lfsmake2 python-rssdler
1310 lfsmake2 python-inotify
1311 lfsmake2 python-docutils
1312 lfsmake2 python-daemon
1313 lfsmake2 python-ipaddress
1314 lfsmake2 glib
f107bb39 1315 lfsmake2 GeoIP
489145db
MT
1316 lfsmake2 ntp
1317 lfsmake2 openssh
1318 lfsmake2 fontconfig
1319 lfsmake2 dejavu-fonts-ttf
70f6cba4 1320 lfsmake2 ubuntu-font-family
489145db
MT
1321 lfsmake2 freefont
1322 lfsmake2 pixman
1323 lfsmake2 cairo
1324 lfsmake2 pango
1325 lfsmake2 rrdtool
1326 lfsmake2 setserial
1327 lfsmake2 setup
1328 lfsmake2 libdnet
1329 lfsmake2 daq
1330 lfsmake2 snort
1331 lfsmake2 oinkmaster
1332 lfsmake2 squid
1333 lfsmake2 squidguard
1334 lfsmake2 calamaris
1335 lfsmake2 tcpdump
1336 lfsmake2 traceroute
1337 lfsmake2 vlan
1338 lfsmake2 wireless
1339 lfsmake2 pakfire
1340 lfsmake2 spandsp
adf3f4f4 1341 lfsmake2 lz4
489145db
MT
1342 lfsmake2 lzo
1343 lfsmake2 openvpn
489145db
MT
1344 lfsmake2 mpage
1345 lfsmake2 dbus
1346 lfsmake2 intltool
1347 lfsmake2 libdaemon
6064cd87 1348 lfsmake2 avahi
489145db 1349 lfsmake2 cups
489145db 1350 lfsmake2 lcms2
56170c2a 1351 lfsmake2 ghostscript
489145db
MT
1352 lfsmake2 qpdf
1353 lfsmake2 poppler
1354 lfsmake2 cups-filters
1355 lfsmake2 epson-inkjet-printer-escpr
1356 lfsmake2 foomatic
1357 lfsmake2 hplip
1358 lfsmake2 cifs-utils
1359 lfsmake2 krb5
1360 lfsmake2 samba
1361 lfsmake2 sudo
1362 lfsmake2 mc
1363 lfsmake2 wget
1364 lfsmake2 bridge-utils
489145db
MT
1365 lfsmake2 smartmontools
1366 lfsmake2 htop
1367 lfsmake2 chkconfig
1368 lfsmake2 postfix
1369 lfsmake2 fetchmail
1370 lfsmake2 cyrus-imapd
489145db
MT
1371 lfsmake2 clamav
1372 lfsmake2 spamassassin
1373 lfsmake2 amavisd
1374 lfsmake2 dma
1375 lfsmake2 alsa
1376 lfsmake2 mpfire
1377 lfsmake2 guardian
1378 lfsmake2 libid3tag
1379 lfsmake2 libmad
1380 lfsmake2 libogg
1381 lfsmake2 libvorbis
1382 lfsmake2 libdvbpsi
1383 lfsmake2 flac
1384 lfsmake2 lame
1385 lfsmake2 sox
41f8d642 1386 lfsmake2 soxr
489145db
MT
1387 lfsmake2 libshout
1388 lfsmake2 xvid
1389 lfsmake2 libmpeg2
489145db
MT
1390 lfsmake2 gnump3d
1391 lfsmake2 rsync
489145db
MT
1392 lfsmake2 libtirpc
1393 lfsmake2 rpcbind
14fb55a5 1394 lfsmake2 keyutils
489145db
MT
1395 lfsmake2 nfs
1396 lfsmake2 gnu-netcat
1397 lfsmake2 ncat
1398 lfsmake2 nmap
489145db
MT
1399 lfsmake2 etherwake
1400 lfsmake2 bwm-ng
1401 lfsmake2 sysstat
489145db
MT
1402 lfsmake2 strongswan
1403 lfsmake2 rng-tools
1404 lfsmake2 lsof
1405 lfsmake2 br2684ctl
1406 lfsmake2 pcmciautils
1407 lfsmake2 lm_sensors
1408 lfsmake2 liboping
1409 lfsmake2 collectd
1410 lfsmake2 elinks
1411 lfsmake2 igmpproxy
1412 lfsmake2 fbset
1413 lfsmake2 opus
1414 lfsmake2 python-six
1415 lfsmake2 python-pyparsing
1416 lfsmake2 spice-protocol
1417 lfsmake2 spice
1418 lfsmake2 sdl
1419 lfsmake2 libusbredir
1420 lfsmake2 qemu
1421 lfsmake2 sane
1422 lfsmake2 netpbm
489145db 1423 lfsmake2 netsnmpd
489145db 1424 lfsmake2 nagios_nrpe
2af354c2 1425 lfsmake2 nagios-plugins
489145db 1426 lfsmake2 icinga
01c2ea6b 1427 lfsmake2 observium-agent
489145db
MT
1428 lfsmake2 ebtables
1429 lfsmake2 directfb
489145db 1430 lfsmake2 faad2
e91ceed6 1431 lfsmake2 alac
489145db
MT
1432 lfsmake2 ffmpeg
1433 lfsmake2 vdr
1434 lfsmake2 vdr_streamdev
489145db
MT
1435 lfsmake2 vdr_epgsearch
1436 lfsmake2 vdr_dvbapi
1437 lfsmake2 vdr_eepg
1438 lfsmake2 w_scan
1439 lfsmake2 icecast
1440 lfsmake2 icegenerator
1441 lfsmake2 mpd
1442 lfsmake2 libmpdclient
1443 lfsmake2 mpc
985741db 1444 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1445 lfsmake2 perl-Net-SMTP-SSL
1446 lfsmake2 perl-MIME-Base64
1447 lfsmake2 perl-Authen-SASL
1448 lfsmake2 perl-MIME-Lite
1449 lfsmake2 perl-Email-Date-Format
1450 lfsmake2 git
1451 lfsmake2 squidclamav
1452 lfsmake2 vnstat
1453 lfsmake2 iw
1454 lfsmake2 wpa_supplicant
1455 lfsmake2 hostapd
1456 lfsmake2 pycurl
1457 lfsmake2 urlgrabber
1458 lfsmake2 syslinux
1459 lfsmake2 tftpd
1460 lfsmake2 cpufrequtils
1461 lfsmake2 bluetooth
1462 lfsmake2 gutenprint
1463 lfsmake2 apcupsd
1464 lfsmake2 iperf
1465 lfsmake2 iperf3
1466 lfsmake2 7zip
1467 lfsmake2 lynis
1468 lfsmake2 streamripper
1469 lfsmake2 sshfs
1470 lfsmake2 taglib
489145db
MT
1471 lfsmake2 sslh
1472 lfsmake2 perl-gettext
1473 lfsmake2 perl-Sort-Naturally
1474 lfsmake2 vdradmin
1475 lfsmake2 miau
1476 lfsmake2 perl-DBI
489145db
MT
1477 lfsmake2 perl-DBD-SQLite
1478 lfsmake2 perl-File-ReadBackwards
489145db 1479 lfsmake2 openvmtools
489145db
MT
1480 lfsmake2 motion
1481 lfsmake2 joe
1482 lfsmake2 monit
1483 lfsmake2 nut
1484 lfsmake2 watchdog
1485 lfsmake2 libpri
1486 lfsmake2 libsrtp
b713ec03 1487 lfsmake2 jansson
489145db 1488 lfsmake2 asterisk
489145db
MT
1489 lfsmake2 usb_modeswitch
1490 lfsmake2 usb_modeswitch_data
1491 lfsmake2 zerofree
489145db
MT
1492 lfsmake2 minicom
1493 lfsmake2 ddrescue
489145db
MT
1494 lfsmake2 miniupnpd
1495 lfsmake2 client175
1496 lfsmake2 powertop
1497 lfsmake2 parted
1498 lfsmake2 swig
2a0947f2 1499 lfsmake2 u-boot
bf1e7598 1500 lfsmake2 u-boot-kirkwood
5c82a9f0 1501 lfsmake2 python-typing
489145db
MT
1502 lfsmake2 python-m2crypto
1503 lfsmake2 wireless-regdb
1504 lfsmake2 crda
1505 lfsmake2 libsolv
1506 lfsmake2 python-distutils-extra
1507 lfsmake2 python-lzma
1508 lfsmake2 python-progressbar
1509 lfsmake2 python-xattr
1510 lfsmake2 ddns
2d17377a 1511 lfsmake2 python3-setuptools
662b2a81 1512 lfsmake2 python3-setuptools-scm
9e25fe5c 1513 lfsmake2 python3-six
e0a05a80 1514 lfsmake2 python3-dateutil
d48ea6b5 1515 lfsmake2 python3-jmespath
a33ca4cc 1516 lfsmake2 python3-colorama
041d2116 1517 lfsmake2 python3-docutils
d2da17a1 1518 lfsmake2 python3-yaml
953f6f73 1519 lfsmake2 python3-s3transfer
d45d5247 1520 lfsmake2 python3-rsa
faa5472a 1521 lfsmake2 python3-pyasn1
4ab80c5d 1522 lfsmake2 python3-botocore
3be81987 1523 lfsmake2 python3-llfuse
def9f4a3 1524 lfsmake2 python3-msgpack
280ee7e7 1525 lfsmake2 aws-cli
489145db
MT
1526 lfsmake2 transmission
1527 lfsmake2 dpfhack
1528 lfsmake2 lcd4linux
1529 lfsmake2 mtr
489145db
MT
1530 lfsmake2 minidlna
1531 lfsmake2 acpid
1532 lfsmake2 fping
1533 lfsmake2 telnet
1534 lfsmake2 xinetd
1535 lfsmake2 gpgme
1536 lfsmake2 pygpgme
1537 lfsmake2 pakfire3
1538 lfsmake2 stress
1539 lfsmake2 libstatgrab
1540 lfsmake2 sarg
1541 lfsmake2 check_mk_agent
1542 lfsmake2 nginx
1543 lfsmake2 sendEmail
1544 lfsmake2 sysbench
1545 lfsmake2 strace
489145db
MT
1546 lfsmake2 ltrace
1547 lfsmake2 ipfire-netboot
1548 lfsmake2 lcdproc
1549 lfsmake2 bitstream
1550 lfsmake2 multicat
1551 lfsmake2 keepalived
1552 lfsmake2 ipvsadm
1553 lfsmake2 perl-Carp-Clan
1554 lfsmake2 perl-Date-Calc
1555 lfsmake2 perl-Date-Manip
1556 lfsmake2 perl-File-Tail
1557 lfsmake2 perl-TimeDate
1558 lfsmake2 swatch
1559 lfsmake2 tor
1560 lfsmake2 arm
1561 lfsmake2 wavemon
1562 lfsmake2 iptraf-ng
1563 lfsmake2 iotop
1564 lfsmake2 stunnel
489145db
MT
1565 lfsmake2 bacula
1566 lfsmake2 batctl
b62c826f
MT
1567 lfsmake2 perl-Font-TTF
1568 lfsmake2 perl-IO-String
489145db
MT
1569 lfsmake2 perl-PDF-API2
1570 lfsmake2 squid-accounting
1571 lfsmake2 pigz
1572 lfsmake2 tmux
1573 lfsmake2 perl-Text-CSV_XS
489145db
MT
1574 lfsmake2 haproxy
1575 lfsmake2 ipset
1576 lfsmake2 lua
1577 lfsmake2 dnsdist
1578 lfsmake2 bird
1a7db134 1579 lfsmake2 frr
489145db
MT
1580 lfsmake2 dmidecode
1581 lfsmake2 mcelog
1582 lfsmake2 rtpproxy
1583 lfsmake2 util-macros
1584 lfsmake2 libpciaccess
1585 lfsmake2 libyajl
1586 lfsmake2 libvirt
1587 lfsmake2 freeradius
1588 lfsmake2 perl-common-sense
1589 lfsmake2 perl-inotify2
1590 lfsmake2 perl-Net-IP
0d6cc79d 1591 lfsmake2 wio
773caa66 1592 lfsmake2 iftop
ddcd60f7 1593 lfsmake2 mdns-repeater
429af178 1594 lfsmake2 i2c-tools
4e9000b4 1595 lfsmake2 nss-myhostname
014b235a 1596 lfsmake2 dehydrated
c708fa15 1597 lfsmake2 shairport-sync
46114d79 1598 lfsmake2 borgbackup
17b3255b 1599 lfsmake2 libedit
2397e513 1600 lfsmake2 knot
e1982c69 1601 lfsmake2 spectre-meltdown-checker
d0817963 1602}
df5e82b3
MT
1603
1604buildinstaller() {
1605 # Run installer scripts one by one
ebaecf2c 1606 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1607 export LOGFILE
489145db
MT
1608 lfsmake2 memtest
1609 lfsmake2 installer
ce9264a1
AF
1610 # use toolchain bash for chroot to strip
1611 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1612}
1613
1614buildpackages() {
ebaecf2c 1615 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1616 export LOGFILE
1617 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1618
df5e82b3
MT
1619
1620 # Generating list of packages used
dc4ae0b7 1621 print_line "Generating packages list from logs"
df5e82b3 1622 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1623 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1624 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1625 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1626 fi
1627 done
7471f6ab 1628 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1629 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1630 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1631 rm -f $BASEDIR/doc/packages-list
c9673262 1632 # packages-list.txt is ready to be displayed for wiki page
f9783277 1633 print_status DONE
4b06f504
MT
1634
1635 # Update changelog
e49f7f0d 1636 cd $BASEDIR
c43b07fd
AF
1637 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1638 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1639 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1640
9607771a 1641 # Create images for install
489145db 1642 lfsmake2 cdrom
bada0832 1643
4dc82852 1644 # Check if there is a loop device for building in virtual environments
841663e7
MT
1645 modprobe loop 2>/dev/null
1646 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1647 lfsmake2 flash-images
4dc82852 1648 fi
c9673262 1649
6b417413 1650 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1651
0d909a4a 1652 ipfirepackages
e67a57fe 1653
489145db 1654 lfsmake2 xen-image
939c2a21 1655 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1656
b307417f 1657 cd $BASEDIR
744a04ea
AF
1658
1659 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1660 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1661
92244a40 1662 for i in `ls *.bz2 *.img.xz *.iso`; do
b307417f
AF
1663 md5sum $i > $i.md5
1664 done
1665 cd $PWD
1666
e67a57fe
MT
1667 # Cleanup
1668 stdumount
1669 rm -rf $BASEDIR/build/tmp/*
1670
e67a57fe 1671 cd $PWD
e67a57fe
MT
1672}
1673
1674ipfirepackages() {
489145db 1675 lfsmake2 core-updates
5596077b
MT
1676
1677 local i
dc7d6b20 1678 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1679 i=$(basename ${i})
453b418b
MT
1680 if [ -e $BASEDIR/lfs/$i ]; then
1681 ipfiredist $i
1682 else
1683 echo -n $i
f9783277 1684 print_status SKIP
453b418b 1685 fi
fe7fe395 1686 done
78331e30 1687 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1688 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1689 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1690}
1691
bcb9dc13
MT
1692while [ $# -gt 0 ]; do
1693 case "${1}" in
1694 --target=*)
c2e810de 1695 configure_build "${1#--target=}"
bcb9dc13
MT
1696 ;;
1697 -*)
1698 exiterror "Unknown configuration option: ${1}"
1699 ;;
1700 *)
1701 # Found a command, so exit options parsing.
1702 break
1703 ;;
1704 esac
1705 shift
1706done
1707
df5e82b3
MT
1708# See what we're supposed to do
1709case "$1" in
1710build)
f9783277
MT
1711 START_TIME=$(now)
1712
1713 # Clear screen
1714 ${INTERACTIVE} && clear
1715
f74072a2 1716 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1717 #only restore on a clean disk
6c4cc7ea 1718 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1719 if [ ! -n "$PACKAGE" ]; then
f9783277 1720 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1721 prepareenv
1722 buildtoolchain
1723 else
f74072a2 1724 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1725 print_build_stage "Packaged toolchain compilation"
df5e82b3 1726 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1727 tar axf $PACKAGE
df5e82b3
MT
1728 prepareenv
1729 else
1730 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1731 fi
1732 fi
1733 else
df5e82b3
MT
1734 prepareenv
1735 fi
5cfe86e6 1736
f9783277 1737 print_build_stage "Building LFS"
df5e82b3 1738 buildbase
15679d9f 1739
f9783277 1740 print_build_stage "Building IPFire"
15679d9f 1741 buildipfire
5cfe86e6 1742
f9783277 1743 print_build_stage "Building installer"
df5e82b3 1744 buildinstaller
15679d9f 1745
f9783277 1746 print_build_stage "Building packages"
df5e82b3 1747 buildpackages
7a5ed24e 1748
f9783277 1749 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1750
1751 cd $BASEDIR
7a5ed24e 1752 tools/checknewlog.pl
e0c923f4 1753 tools/checkrootfiles
b307417f 1754 cd $PWD
a23731d1 1755
f9783277 1756 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1757 ;;
1758shell)
1759 # enter a shell inside LFS chroot
1760 # may be used to changed kernel settings
1761 prepareenv
1762 entershell
1763 ;;
df5e82b3 1764clean)
f9783277
MT
1765 print_line "Cleaning build directory..."
1766
df5e82b3
MT
1767 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1768 $LOSETUP -d $i 2>/dev/null
1769 done
1770 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1771 umount $i
1772 done
1773 stdumount
1774 for i in `seq 0 7`; do
69a6ec55 1775 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1776 umount /dev/loop${i} 2>/dev/null;
1777 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1778 fi;
df5e82b3
MT
1779 done
1780 rm -rf $BASEDIR/build
1781 rm -rf $BASEDIR/cdrom
f9315063 1782 rm -rf $BASEDIR/packages
ebaecf2c 1783 rm -rf $BASEDIR/log
6c4cc7ea
MT
1784 if [ -h "${TOOLS_DIR}" ]; then
1785 rm -f "${TOOLS_DIR}"
df5e82b3 1786 fi
b307417f 1787 rm -f $BASEDIR/ipfire-*
f9783277 1788 print_status DONE
df5e82b3 1789 ;;
4e432799
MT
1790docker)
1791 # Build the docker image if it does not exist, yet
1792 if ! docker images -a | grep -q ^ipfire-builder; then
1793 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1794 print_status DONE
1795 else
1796 print_status FAIL
1797 exit 1
1798 fi
1799 fi
1800
1801 # Run the container and enter a shell
1802 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1803 ;;
c3db995c 1804downloadsrc)
df5e82b3
MT
1805 if [ ! -d $BASEDIR/cache ]; then
1806 mkdir $BASEDIR/cache
1807 fi
ebaecf2c 1808 mkdir -p $BASEDIR/log
857d9bf2 1809 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1810 FINISHED=0
1811 cd $BASEDIR/lfs
1812 for c in `seq $MAX_RETRIES`; do
1813 if (( FINISHED==1 )); then
1814 break
1815 fi
1816 FINISHED=1
1817 cd $BASEDIR/lfs
1818 for i in *; do
1819 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1820 lfsmakecommoncheck ${i} || continue
1821
dc7d6b20 1822 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1823 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1824 if [ $? -ne 0 ]; then
f9783277 1825 print_status FAIL
df5e82b3
MT
1826 FINISHED=0
1827 else
1828 if [ $c -eq 1 ]; then
f9783277 1829 print_status DONE
df5e82b3
MT
1830 fi
1831 fi
1832 fi
1833 done
1834 done
e22c7973 1835 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1836 ERROR=0
1837 for i in *; do
1838 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1839 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1840 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1841 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1842 if [ $? -ne 0 ]; then
e22c7973 1843 echo -ne "MD5 difference in lfs/$i"
f9783277 1844 print_status FAIL
df5e82b3
MT
1845 ERROR=1
1846 fi
1847 fi
1848 done
1849 if [ $ERROR -eq 0 ]; then
e22c7973 1850 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1851 print_status DONE
e22c7973
MT
1852 else
1853 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1854 print_status FAIL
df5e82b3 1855 fi
e22c7973 1856 cd - >/dev/null 2>&1
df5e82b3 1857 ;;
df5e82b3 1858toolchain)
f9783277
MT
1859 # Clear screen
1860 ${INTERACTIVE} && clear
1861
df5e82b3 1862 prepareenv
f3b7cf47 1863 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1864 buildtoolchain
f74072a2 1865 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1866 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
ebaecf2c 1867 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
b46f951e 1868 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
f74072a2 1869 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1870 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1871 stdumount
1872 ;;
1873gettoolchain)
df5e82b3 1874 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1875 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1876 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1877 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1878 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1879 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1880 cd $BASEDIR/cache/toolchains
f74072a2 1881 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1882 if [ $? -ne 0 ]; then
dc7d6b20 1883 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1884 else
f74072a2 1885 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1886 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1887 else
1888 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1889 fi
40a4ea4c 1890 fi
712d859c
MT
1891 else
1892 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1893 fi
1894 ;;
15679d9f
MT
1895uploadsrc)
1896 PWD=`pwd`
661d9388
CS
1897 if [ -z $IPFIRE_USER ]; then
1898 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1899 print_status FAIL
661d9388
CS
1900 exit 1
1901 fi
ae23a606 1902
661d9388 1903 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1904 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1905
15e38431
MT
1906 for file in ${BASEDIR}/cache/*; do
1907 [ -d "${file}" ] && continue
1908 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1909 NEW_FILES="$NEW_FILES $file"
0eab8e84 1910 done
661d9388
CS
1911 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1912 cd $BASEDIR
15679d9f
MT
1913 cd $PWD
1914 exit 0
0eab8e84 1915 ;;
bf7c473f 1916lang)
69a6ec55
MT
1917 echo -ne "Checking the translations for missing or obsolete strings..."
1918 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1919 $BASEDIR/tools/sort_strings.pl en
1920 $BASEDIR/tools/sort_strings.pl de
1921 $BASEDIR/tools/sort_strings.pl fr
1922 $BASEDIR/tools/sort_strings.pl es
1923 $BASEDIR/tools/sort_strings.pl pl
1924 $BASEDIR/tools/sort_strings.pl ru
1925 $BASEDIR/tools/sort_strings.pl nl
1926 $BASEDIR/tools/sort_strings.pl tr
1927 $BASEDIR/tools/sort_strings.pl it
1928 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1929 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1930 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1931 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1932 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1933 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1934 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1935 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1936 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1937 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1938 print_status DONE
69a6ec55
MT
1939
1940 echo -ne "Updating language lists..."
1941 update_language_list ${BASEDIR}/src/installer/po
1942 update_language_list ${BASEDIR}/src/setup/po
f9783277 1943 print_status DONE
bf7c473f 1944 ;;
1fb7f56e
MT
1945update-contributors)
1946 update_contributors
1947 ;;
6b8cff41 1948*)
1fb7f56e 1949 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
6b8cff41
MT
1950 cat doc/make.sh-usage
1951 ;;
3ea75603 1952esac